using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace PhotoControllerDemo
{
    public partial class frmMarble : Form
    {
        public frmMarble()
        {
            InitializeComponent();
        }

        private void frmMarble_Load(object sender, EventArgs e)
        {
            trackLevel.Value = 5;
            trackMovement.Value = 5;
            trackTurbulence.Value = 1;
            comboBox1.SelectedIndex = 1;
            trackLevel_Scroll(this, e);
            trackMovement_Scroll(this, e);
            trackTurbulence_Scroll(this, e);
        }

        private void trackLevel_Scroll(object sender, EventArgs e)
        {
            this.labLevel.Text = "Level (" + trackLevel.Value.ToString() + ")";
        }

        private void trackMovement_Scroll(object sender, EventArgs e)
        {
            this.labMovement.Text = "Movement (" + trackMovement.Value.ToString() + ")";
        }

        private void trackTurbulence_Scroll(object sender, EventArgs e)
        {
            this.label1.Text = "Turbulence (" + trackTurbulence.Value.ToString() + ")";
        }
    }
}