using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace PhotoControllerDemo
{
	/// <summary>
	/// frmSaveGif 
	/// </summary>
	public class frmSaveGif : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		public System.Windows.Forms.ComboBox comboBox1;
		private System.Windows.Forms.Label label2;
		public System.Windows.Forms.TrackBar barColor;
		private System.Windows.Forms.Button btOK;
		private System.Windows.Forms.Button btClose;
		private System.Windows.Forms.Label lbeMaxColor;
		public System.Windows.Forms.CheckBox chkTransparent;
		private System.Windows.Forms.ColorDialog dlgColor;
		public System.Windows.Forms.Button btColor;

		private System.ComponentModel.Container components = null;

		public frmSaveGif()
		{
			InitializeComponent();
		}

		/// <summary>
		/// Release resources
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Initialize
		/// <summary>
		/// 
		/// 
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.comboBox1 = new System.Windows.Forms.ComboBox();
			this.label2 = new System.Windows.Forms.Label();
			this.lbeMaxColor = new System.Windows.Forms.Label();
			this.barColor = new System.Windows.Forms.TrackBar();
			this.btOK = new System.Windows.Forms.Button();
			this.btClose = new System.Windows.Forms.Button();
			this.chkTransparent = new System.Windows.Forms.CheckBox();
			this.dlgColor = new System.Windows.Forms.ColorDialog();
			this.btColor = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.barColor)).BeginInit();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(8, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(74, 18);
			this.label1.TabIndex = 0;
			this.label1.Text = "Saving GIF";
			// 
			// comboBox1
			// 
			this.comboBox1.DisplayMember = "0";
			this.comboBox1.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBox1.Items.AddRange(new object[] {
														   "GifAdaptive",
														   "GifOctreeQuantizer",
														   "GifStandard256",
														   "GifWebSafe"});
			this.comboBox1.Location = new System.Drawing.Point(112, 40);
			this.comboBox1.Name = "comboBox1";
			this.comboBox1.Size = new System.Drawing.Size(121, 22);
			this.comboBox1.TabIndex = 1;
			this.comboBox1.SelectedIndexChanged += new System.EventHandler(this.comboBox1_SelectedIndexChanged);
			// 
			// label2
			// 
			this.label2.AutoSize = true;
			this.label2.Location = new System.Drawing.Point(8, 48);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(102, 16);
			this.label2.TabIndex = 2;
			this.label2.Text = "Compression Type:";
			// 
			// lbeMaxColor
			// 
			this.lbeMaxColor.AutoSize = true;
			this.lbeMaxColor.Location = new System.Drawing.Point(16, 112);
			this.lbeMaxColor.Name = "lbeMaxColor";
			this.lbeMaxColor.Size = new System.Drawing.Size(85, 16);
			this.lbeMaxColor.TabIndex = 3;
			this.lbeMaxColor.Text = "Max Color (256)";
			// 
			// barColor
			// 
			this.barColor.BackColor = System.Drawing.SystemColors.ScrollBar;
			this.barColor.Location = new System.Drawing.Point(104, 104);
			this.barColor.Maximum = 256;
			this.barColor.Name = "barColor";
			this.barColor.Size = new System.Drawing.Size(256, 42);
			this.barColor.TabIndex = 4;
			this.barColor.TickFrequency = 10;
			this.barColor.Value = 256;
			this.barColor.Scroll += new System.EventHandler(this.barColor_Scroll);
			// 
			// btOK
			// 
			this.btOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btOK.Location = new System.Drawing.Point(176, 152);
			this.btOK.Name = "btOK";
			this.btOK.TabIndex = 5;
			this.btOK.Text = "OK";
			// 
			// btClose
			// 
			this.btClose.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btClose.Location = new System.Drawing.Point(280, 152);
			this.btClose.Name = "btClose";
			this.btClose.TabIndex = 6;
			this.btClose.Text = "Close";
			// 
			// chkTransparent
			// 
			this.chkTransparent.Location = new System.Drawing.Point(112, 72);
			this.chkTransparent.Name = "chkTransparent";
			this.chkTransparent.TabIndex = 7;
			this.chkTransparent.Text = "Transparent";
			// 
			// btColor
			// 
			this.btColor.BackColor = System.Drawing.Color.Black;
			this.btColor.Cursor = System.Windows.Forms.Cursors.Hand;
			this.btColor.Location = new System.Drawing.Point(216, 72);
			this.btColor.Name = "btColor";
			this.btColor.Size = new System.Drawing.Size(24, 23);
			this.btColor.TabIndex = 8;
			this.btColor.Click += new System.EventHandler(this.btColor_Click);
			// 
			// frmSaveGif
			// 
			this.AcceptButton = this.btOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btClose;
			this.ClientSize = new System.Drawing.Size(376, 186);
			this.Controls.Add(this.btColor);
			this.Controls.Add(this.chkTransparent);
			this.Controls.Add(this.btClose);
			this.Controls.Add(this.btOK);
			this.Controls.Add(this.barColor);
			this.Controls.Add(this.lbeMaxColor);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.comboBox1);
			this.Controls.Add(this.label1);
			this.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			this.Name = "frmSaveGif";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Save GIF";
			((System.ComponentModel.ISupportInitialize)(this.barColor)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void barColor_Scroll(object sender, System.EventArgs e)
		{
			this.lbeMaxColor.Text = "Max Color (" + barColor.Value.ToString() + ")";
		}

		private void comboBox1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			//reset controls
			this.barColor.Enabled = true;
			this.chkTransparent.Enabled = true;
			this.btColor.Enabled = true;
			this.lbeMaxColor.Enabled = true;

			// only GifOctreeQuantizer mode supports a specified maximun color number
			if (comboBox1.SelectedIndex == 0 || comboBox1.SelectedIndex == 2 || comboBox1.SelectedIndex == 3)
			{
				this.barColor.Enabled = false;
				this.lbeMaxColor.Enabled = false;

				// for GifStandard256, it's always transparent; 
				// and you can't specify a transparency color, because the color palette is full
				if (comboBox1.SelectedIndex == 2)
				{
					this.chkTransparent.Checked = true;
					this.chkTransparent.Enabled = false;
					this.btColor.Enabled = false;
				}
			}
			else if (comboBox1.SelectedIndex == 1)
			{
				// foro GifOctreeQuantizer mode, it's always non-transparent; 
				// so you must specify a transparency color, default is Black
				this.chkTransparent.Checked = false;
				this.chkTransparent.Enabled = false;
				this.barColor.Enabled = true;
				this.lbeMaxColor.Enabled = true;
			}
		}

		private void btColor_Click(object sender, System.EventArgs e)
		{
			if (dlgColor.ShowDialog() == DialogResult.OK)
			{
				btColor.BackColor = dlgColor.Color;
			}
		}
	}
}
