using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;
using IC.PhotoController.Border;
using BorderStyle = IC.PhotoController.Border.BorderStyle;

namespace PhotoControllerDemo
{
    /// <summary>
    /// Summary description for frmBorder.
    /// </summary>
    public class frmBorder : Form
    {
        private Button btOK;
        private Button btCancel;
        internal TrackBar trackLength;
        private Label lbeLength;
        private ColorDialog dlgColor;
        private GroupBox groupBox1;
        private NumericUpDown numBrushLength;
        private Label label2;
        internal ComboBox cboxBorderStyle;
        private Label lbeBorderStyle;
        private Button btColor;
        private Label labColor;
        private Button btColor2;
        private GroupBox groupBox2;
        private CheckBox chkWEST;
        private CheckBox chkSOUTH;
        private CheckBox chkEAST;
        private CheckBox chkALL;
        private CheckBox chkNORTH;
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private Container components = null;

        public frmBorder()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            _builder = new BorderBuilder();
            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.btOK = new System.Windows.Forms.Button();
            this.btCancel = new System.Windows.Forms.Button();
            this.trackLength = new System.Windows.Forms.TrackBar();
            this.lbeLength = new System.Windows.Forms.Label();
            this.dlgColor = new System.Windows.Forms.ColorDialog();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.btColor2 = new System.Windows.Forms.Button();
            this.btColor = new System.Windows.Forms.Button();
            this.labColor = new System.Windows.Forms.Label();
            this.numBrushLength = new System.Windows.Forms.NumericUpDown();
            this.label2 = new System.Windows.Forms.Label();
            this.cboxBorderStyle = new System.Windows.Forms.ComboBox();
            this.lbeBorderStyle = new System.Windows.Forms.Label();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.chkALL = new System.Windows.Forms.CheckBox();
            this.chkNORTH = new System.Windows.Forms.CheckBox();
            this.chkWEST = new System.Windows.Forms.CheckBox();
            this.chkSOUTH = new System.Windows.Forms.CheckBox();
            this.chkEAST = new System.Windows.Forms.CheckBox();
            ((System.ComponentModel.ISupportInitialize)(this.trackLength)).BeginInit();
            this.groupBox1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.numBrushLength)).BeginInit();
            this.groupBox2.SuspendLayout();
            this.SuspendLayout();
            // 
            // btOK
            // 
            this.btOK.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.btOK.Location = new System.Drawing.Point(381, 215);
            this.btOK.Name = "btOK";
            this.btOK.Size = new System.Drawing.Size(75, 23);
            this.btOK.TabIndex = 0;
            this.btOK.Text = "OK";
            this.btOK.Click += new System.EventHandler(this.btOK_Click);
            // 
            // btCancel
            // 
            this.btCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.btCancel.Location = new System.Drawing.Point(381, 258);
            this.btCancel.Name = "btCancel";
            this.btCancel.Size = new System.Drawing.Size(75, 23);
            this.btCancel.TabIndex = 1;
            this.btCancel.Text = "Cancel";
            // 
            // trackLength
            // 
            this.trackLength.Location = new System.Drawing.Point(19, 27);
            this.trackLength.Maximum = 100;
            this.trackLength.Name = "trackLength";
            this.trackLength.Size = new System.Drawing.Size(352, 42);
            this.trackLength.TabIndex = 3;
            this.trackLength.TickFrequency = 10;
            this.trackLength.Value = 10;
            this.trackLength.Scroll += new System.EventHandler(this.trackLength_Scroll);
            // 
            // lbeLength
            // 
            this.lbeLength.AutoSize = true;
            this.lbeLength.Location = new System.Drawing.Point(16, 9);
            this.lbeLength.Name = "lbeLength";
            this.lbeLength.Size = new System.Drawing.Size(109, 15);
            this.lbeLength.TabIndex = 4;
            this.lbeLength.Text = "Border Length - 10";
            // 
            // dlgColor
            // 
            this.dlgColor.AnyColor = true;
            this.dlgColor.Color = System.Drawing.Color.Transparent;
            this.dlgColor.FullOpen = true;
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.btColor2);
            this.groupBox1.Controls.Add(this.btColor);
            this.groupBox1.Controls.Add(this.labColor);
            this.groupBox1.Controls.Add(this.numBrushLength);
            this.groupBox1.Controls.Add(this.label2);
            this.groupBox1.Controls.Add(this.cboxBorderStyle);
            this.groupBox1.Controls.Add(this.lbeBorderStyle);
            this.groupBox1.Location = new System.Drawing.Point(19, 137);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(356, 144);
            this.groupBox1.TabIndex = 11;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Brush Settings";
            // 
            // btColor2
            // 
            this.btColor2.BackColor = System.Drawing.Color.Black;
            this.btColor2.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btColor2.Location = new System.Drawing.Point(133, 107);
            this.btColor2.Name = "btColor2";
            this.btColor2.Size = new System.Drawing.Size(26, 23);
            this.btColor2.TabIndex = 15;
            this.btColor2.UseVisualStyleBackColor = false;
            this.btColor2.Visible = false;
            this.btColor2.Click += new System.EventHandler(this.btColor2_Click);
            // 
            // btColor
            // 
            this.btColor.BackColor = System.Drawing.SystemColors.ControlText;
            this.btColor.Cursor = System.Windows.Forms.Cursors.Hand;
            this.btColor.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btColor.Location = new System.Drawing.Point(103, 107);
            this.btColor.Name = "btColor";
            this.btColor.Size = new System.Drawing.Size(24, 23);
            this.btColor.TabIndex = 14;
            this.btColor.UseVisualStyleBackColor = false;
            this.btColor.Click += new System.EventHandler(this.btColor_Click);
            // 
            // labColor
            // 
            this.labColor.AutoSize = true;
            this.labColor.Location = new System.Drawing.Point(9, 107);
            this.labColor.Name = "labColor";
            this.labColor.Size = new System.Drawing.Size(74, 15);
            this.labColor.TabIndex = 13;
            this.labColor.Text = "CentreColor";
            // 
            // numBrushLength
            // 
            this.numBrushLength.Location = new System.Drawing.Point(103, 72);
            this.numBrushLength.Name = "numBrushLength";
            this.numBrushLength.Size = new System.Drawing.Size(137, 21);
            this.numBrushLength.TabIndex = 12;
            this.numBrushLength.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Location = new System.Drawing.Point(9, 78);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(78, 15);
            this.label2.TabIndex = 11;
            this.label2.Text = "BrushLength";
            // 
            // cboxBorderStyle
            // 
            this.cboxBorderStyle.Location = new System.Drawing.Point(102, 39);
            this.cboxBorderStyle.Name = "cboxBorderStyle";
            this.cboxBorderStyle.Size = new System.Drawing.Size(232, 23);
            this.cboxBorderStyle.TabIndex = 10;
            this.cboxBorderStyle.SelectedIndexChanged += new System.EventHandler(this.cboxBorderStyle_SelectedIndexChanged);
            // 
            // lbeBorderStyle
            // 
            this.lbeBorderStyle.AutoSize = true;
            this.lbeBorderStyle.Location = new System.Drawing.Point(9, 47);
            this.lbeBorderStyle.Name = "lbeBorderStyle";
            this.lbeBorderStyle.Size = new System.Drawing.Size(70, 15);
            this.lbeBorderStyle.TabIndex = 9;
            this.lbeBorderStyle.Text = "BorderStyle";
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.chkALL);
            this.groupBox2.Controls.Add(this.chkNORTH);
            this.groupBox2.Controls.Add(this.chkWEST);
            this.groupBox2.Controls.Add(this.chkSOUTH);
            this.groupBox2.Controls.Add(this.chkEAST);
            this.groupBox2.Location = new System.Drawing.Point(19, 60);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(356, 71);
            this.groupBox2.TabIndex = 12;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "Border Alignment";
            // 
            // chkALL
            // 
            this.chkALL.AutoSize = true;
            this.chkALL.Location = new System.Drawing.Point(12, 48);
            this.chkALL.Name = "chkALL";
            this.chkALL.Size = new System.Drawing.Size(47, 19);
            this.chkALL.TabIndex = 4;
            this.chkALL.Text = "ALL";
            this.chkALL.UseVisualStyleBackColor = true;
            this.chkALL.CheckedChanged += new System.EventHandler(this.chkALL_CheckedChanged);
            // 
            // chkNORTH
            // 
            this.chkNORTH.AutoSize = true;
            this.chkNORTH.Location = new System.Drawing.Point(265, 20);
            this.chkNORTH.Name = "chkNORTH";
            this.chkNORTH.Size = new System.Drawing.Size(69, 19);
            this.chkNORTH.TabIndex = 3;
            this.chkNORTH.Text = "NORTH";
            this.chkNORTH.UseVisualStyleBackColor = true;
            this.chkNORTH.CheckedChanged += new System.EventHandler(this.chkEAST_CheckedChanged);
            // 
            // chkWEST
            // 
            this.chkWEST.AutoSize = true;
            this.chkWEST.Location = new System.Drawing.Point(180, 20);
            this.chkWEST.Name = "chkWEST";
            this.chkWEST.Size = new System.Drawing.Size(60, 19);
            this.chkWEST.TabIndex = 2;
            this.chkWEST.Text = "WEST";
            this.chkWEST.UseVisualStyleBackColor = true;
            this.chkWEST.CheckedChanged += new System.EventHandler(this.chkEAST_CheckedChanged);
            // 
            // chkSOUTH
            // 
            this.chkSOUTH.AutoSize = true;
            this.chkSOUTH.Location = new System.Drawing.Point(91, 20);
            this.chkSOUTH.Name = "chkSOUTH";
            this.chkSOUTH.Size = new System.Drawing.Size(68, 19);
            this.chkSOUTH.TabIndex = 1;
            this.chkSOUTH.Text = "SOUTH";
            this.chkSOUTH.UseVisualStyleBackColor = true;
            this.chkSOUTH.CheckedChanged += new System.EventHandler(this.chkEAST_CheckedChanged);
            // 
            // chkEAST
            // 
            this.chkEAST.AutoSize = true;
            this.chkEAST.Location = new System.Drawing.Point(12, 20);
            this.chkEAST.Name = "chkEAST";
            this.chkEAST.Size = new System.Drawing.Size(56, 19);
            this.chkEAST.TabIndex = 0;
            this.chkEAST.Text = "EAST";
            this.chkEAST.UseVisualStyleBackColor = true;
            this.chkEAST.CheckedChanged += new System.EventHandler(this.chkEAST_CheckedChanged);
            // 
            // frmBorder
            // 
            this.AcceptButton = this.btOK;
            this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
            this.CancelButton = this.btCancel;
            this.ClientSize = new System.Drawing.Size(467, 294);
            this.Controls.Add(this.groupBox2);
            this.Controls.Add(this.groupBox1);
            this.Controls.Add(this.lbeLength);
            this.Controls.Add(this.trackLength);
            this.Controls.Add(this.btCancel);
            this.Controls.Add(this.btOK);
            this.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
            this.Name = "frmBorder";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
            this.Text = "Border";
            this.Load += new System.EventHandler(this.frmBorder_Load);
            ((System.ComponentModel.ISupportInitialize)(this.trackLength)).EndInit();
            this.groupBox1.ResumeLayout(false);
            this.groupBox1.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.numBrushLength)).EndInit();
            this.groupBox2.ResumeLayout(false);
            this.groupBox2.PerformLayout();
            this.ResumeLayout(false);
            this.PerformLayout();

        }
        #endregion

        private BorderBuilder _builder;

        public BorderBuilder BorderBuilder
        {
            get { return _builder; }
        }

        private int count_BorderStyle = 0;
        private void frmBorder_Load(object sender, EventArgs e)
        {

            // first, build the existing PhotoBorderStyle
            string[] bs;
            bs = Enum.GetNames(typeof(IC.PhotoController.Border.BorderStyle));
            foreach (string sbs in bs)
            {
                cboxBorderStyle.Items.Add("PhotoBorderStyle." + sbs);
                count_BorderStyle++;
            }

            // second, add HatchStyle
            // building HatchStyle dropdown is a trick, see 
            // ms-help://MS.MSDNQTR.v80.en/MS.MSDN.v80/MS.WIN32COM.v10.en/gdicpp/GDIPlus/GDIPlusreference/enumerations/hatchstyle.htm
            // you have to skip HatchStyle.LargeGrid, HatchStyle.Min, and HatchStyle.Max 
            bs = Enum.GetNames(typeof(HatchStyle));
            foreach (string sbs in bs)
            {
                if (sbs == "LargeGrid" || sbs == "Min" || sbs == "Max") continue;
                cboxBorderStyle.Items.Add("HatchStyle." + sbs);
            }

            // default selection
            cboxBorderStyle.SelectedIndex = 0;
            chkALL.Checked = true;
            btColor.Visible = true;
            btColor.BackColor = Color.White;
            dlgColor.Color = Color.DarkRed;
            numBrushLength.Value = trackLength.Value;
        }

        private void trackLength_Scroll(object sender, EventArgs e)
        {
            this.lbeLength.Text = "Border length - " + trackLength.Value.ToString();
            this.numBrushLength.Value = trackLength.Value;
        }

        private void btColor_Click(object sender, EventArgs e)
        {
            if (dlgColor.ShowDialog() == DialogResult.OK)
            {
                btColor.BackColor = dlgColor.Color;
            }
        }

        private void btOK_Click(object sender, EventArgs e)
        {
            // build the BorderBuilder object
            _builder.Length = this.trackLength.Value;

            BorderAlignment alignment = BorderAlignment.NONE;

            if (chkEAST.Checked)
                alignment = BorderAlignment.EAST;
            if (chkSOUTH.Checked)
                alignment = alignment | BorderAlignment.SOUTH;
            if (chkWEST.Checked)
                alignment = alignment | BorderAlignment.WEST;
            if (chkNORTH.Checked)
                alignment = alignment | BorderAlignment.NORTH;
            if (chkALL.Checked)
                alignment = BorderAlignment.ALL;

            _builder.Alignment = alignment;

            int brushLength = (int)this.numBrushLength.Value;

            PathGradientBrush pb = null;

            // if the user selects a PhotoBorderStyle, we need to use BorderBuilder.CreateXXXBrush methods
            // to create special brush to draw
            if (this.cboxBorderStyle.SelectedIndex < count_BorderStyle)
            {
                BorderStyle style = (BorderStyle)this.cboxBorderStyle.SelectedIndex;
                switch (style)
                {
                    case BorderStyle.Arch:
                        pb = BorderBuilder.CreateArchBrush(brushLength);
                        break;
                    case BorderStyle.Ball3D:
                        pb = BorderBuilder.CreateBall3dBrush(brushLength);
                        break;
                    case BorderStyle.BambooLeaf:
                        pb = BorderBuilder.CreateBambooLeafBrush(brushLength);
                        break;
                    case BorderStyle.Comb:
                        pb = BorderBuilder.CreateCombBrush(brushLength);
                        break;
                    case BorderStyle.Sawtooth:
                        pb = BorderBuilder.CreateSawtoothBrush(brushLength);
                        break;
                    case BorderStyle.HaloStar:
                        pb = BorderBuilder.CreateHaloStarBrush(brushLength);
                        break;
                    case BorderStyle.Diamond:
                        pb = BorderBuilder.CreateDiamondBrush(brushLength);
                        break;
                    case BorderStyle.FlyingLeaf:
                        pb = IC.PhotoController.Border.BorderBuilder.CreateFlyingLeafBrush(brushLength);
                        break;
                    case BorderStyle.Silk:
                        pb = IC.PhotoController.Border.BorderBuilder.CreateSilkBrush(brushLength);
                        break;
                    case BorderStyle.Brick:
                        pb = IC.PhotoController.Border.BorderBuilder.CreateBrickBrush(brushLength);
                        break;
                }
                if (pb != null) pb.CenterColor = btColor.BackColor;
                _builder.Brush = pb;
            }
            else
            {
                HatchStyle style = (HatchStyle)(this.cboxBorderStyle.SelectedIndex - count_BorderStyle);
                HatchBrush brush = new HatchBrush(style, btColor.BackColor, btColor2.BackColor);
                _builder.Brush = brush;
            }

            this.DialogResult = DialogResult.OK;
        }

        private void cboxBorderStyle_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cboxBorderStyle.SelectedIndex >= count_BorderStyle)
            {
                labColor.Text = "F/B Color";
                btColor2.Visible = true;
            }
            else
            {
                labColor.Text = "CentreColor";
                btColor2.Visible = false;
            }
        }

        private void btColor2_Click(object sender, EventArgs e)
        {
            if (dlgColor.ShowDialog() == DialogResult.OK)
            {
                btColor2.BackColor = dlgColor.Color;
            }
        }

        private void chkALL_CheckedChanged(object sender, EventArgs e)
        {
            if (chkALL.CheckState == CheckState.Checked) 
                chkEAST.Checked = chkSOUTH.Checked = chkWEST.Checked = chkNORTH.Checked = false;
        }

        private void chkEAST_CheckedChanged(object sender, EventArgs e)
        {
            if (chkALL.CheckState == CheckState.Checked && (sender as CheckBox).CheckState == CheckState.Checked)
                chkALL.CheckState = CheckState.Unchecked;
        }
    }
}
