using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace PhotoControllerDemo
{
    public partial class frmSphere : Form
    {
        public frmSphere()
        {
            InitializeComponent();
        }

        private void trackLevel_Scroll(object sender, EventArgs e)
        {
            this.label1.Text = "Radius (" + trackLevel.Value.ToString() + ")";
        }

        private void trackCenterX_Scroll(object sender, EventArgs e)
        {
            this.labCenterX.Text = "Center X (" + trackCenterX.Value.ToString() + ")";
        }

        private void trackCenterY_Scroll(object sender, EventArgs e)
        {
            this.labCenterY.Text = "Center Y (" + trackCenterY.Value.ToString() + ")";
        }

        private void frmSphere_Load(object sender, EventArgs e)
        {
            trackLevel.Value = 100;
            trackCenterX.Value = 50;
            trackCenterY.Value = 50;
            trackProtrusion.Value = 5;
            comboBox1.SelectedIndex = 2;
            trackLevel_Scroll(this, e);
            trackProtrusion_Scroll(this, e);
            trackCenterX_Scroll(this, e);
            trackCenterY_Scroll(this, e);
        }

        private void trackProtrusion_Scroll(object sender, EventArgs e)
        {
            this.label2.Text = "Zoom (" + trackProtrusion.Value.ToString() + ")";
        }
    }
}