using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace PhotoControllerDemo
{
    public partial class frmWaterRipple : Form
    {
        public frmWaterRipple()
        {
            InitializeComponent();
        }

        private void frmWaterRipple_Load(object sender, EventArgs e)
        {
            trackWave.Value = 25;
            trackLevel.Value = 200;
            trackAmplitude.Value = 10;
            trackAngle.Value = 50;
            trackCenterX.Value = 50;
            trackCenterY.Value = 50;
            comboBox1.SelectedIndex = 1;
            trackLevel_Scroll(this, e);
            trackWave_Scroll(this, e);
            trackAmplitude_Scroll(this, e);
            trackAngle_Scroll(this, e);
            trackCenterX_Scroll(this, e);
            trackCenterY_Scroll(this, e);
        }

        private void trackLevel_Scroll(object sender, EventArgs e)
        {
            this.label1.Text = "Level (" + trackLevel.Value.ToString() + ")";
        }

        private void trackWave_Scroll(object sender, EventArgs e)
        {
            label2.Text = "Wave (" + trackWave.Value.ToString() + ")";
        }

        private void trackAmplitude_Scroll(object sender, EventArgs e)
        {
            this.labAmplitude.Text = "Amplitude (" + trackAmplitude.Value.ToString() + ")";
        }

        private void trackAngle_Scroll(object sender, EventArgs e)
        {
            this.labAngle.Text = "Angle (" + trackAngle.Value.ToString() + ")";
        }

        private void trackCenterX_Scroll(object sender, EventArgs e)
        {
            this.labCenterX.Text = "Center X (" + trackCenterX.Value.ToString() + ")";
        }

        private void trackCenterY_Scroll(object sender, EventArgs e)
        {
            this.labCenterY.Text = "Center Y (" + trackCenterY.Value.ToString() + ")";
        }
    }
}