Imports IC.PhotoController
Imports IC.PhotoController.Filter

Namespace PhotoControllerWebDemoVB


    Partial Class WebForm1

        Inherits System.Web.UI.Page

#Region " Web form initialized code "

        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub

        Private designerPlaceholderDeclaration As System.Object
        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            InitializeComponent()
        End Sub

#End Region

        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        End Sub

        Private Sub rbColor_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbColor.SelectedIndexChanged
            If (Page.IsPostBack) Then
                Response.ContentType = "image/jpeg"

                Dim objpc As IC.PhotoController.Controller
                objpc = New IC.PhotoController.Controller
                Dim img As System.Drawing.Image
                img = System.Drawing.Image.FromFile(Server.MapPath("..") + "\PhotoControllerWebDemoVB\" + image.ImageUrl)
                objpc.LoadImage(img)

                Select Case (rbColor.SelectedIndex)
                    Case 0
                        img = objpc.Filter(FilterStyle.GrayScale)
                    Case 1
                        img = objpc.Filter(New GreyColorFilter)
                    Case 2
                        img = objpc.Filter(FilterStyle.Invert)
                    Case 3
                        Dim filter As SepiaFilter = New SepiaFilter()
                        filter.Level = 21
                        img = objpc.Filter(filter)
                    Case 4
                        img = objpc.Flip(FlipFlags.FlipHorizontal)
                    Case 5
                        img = objpc.Flip(FlipFlags.FlipVertical)
                    Case 6
                        img = objpc.Flip(FlipFlags.FlipBoth)
                    Case 7
                        Dim filter As ContrastFilter = New ContrastFilter()
                        filter.Level = 20
                        img = objpc.Filter(filter)
                    Case 8
                        Dim filter As EmbossFilter = New EmbossFilter()
                        filter.Level = 3
                        filter.Direction = 120
                        img = objpc.Filter(filter)
                End Select

                Dim b As Bitmap
                b = New Bitmap(img)
                Dim oStream As New System.IO.MemoryStream
                Response.ClearContent()
                b.Save(oStream, System.Drawing.Imaging.ImageFormat.Jpeg)
                Response.BinaryWrite(oStream.ToArray())

                ' release all resource
                objpc.Dispose()
                b.Dispose()

                Response.End()

            End If
        End Sub
    End Class

End Namespace
